/*tank NIOS DE1-SoC*/

.include "nios_macros.s"
.equ GPIO_PORT1,	 0xFF200060
.equ GPIO_PORT2,	 0xFF200070
.equ ADDR_REDLEDS,   0xFF200000	 	/* RED LEDs*/
.equ ADDR_SWITCHES,  0xFF200040	 	/* switches*/
.equ ADDR_7SEGS_low, 0xFF200020	 	/* 7 segment display 0-3*/
.equ ADDR_7SEGS_high,0xFF200030	 	/* 7 segment display 4-7*/

.text

.global _start

_start:
/*r2 is GPIO port*/
/*r3 is direction*/
/*r4 is sensor*/
/*r5 is control*/
/*r6 is RED LEDs*/
/*r7 is switches*/
/*r8 is comparator*/
/*r9 is motor variable*/
  
 movia  r2, GPIO_PORT2              /* set (motors,sensors,control 0-3) for output  (control 4-7) for input*/
 movia  r3, 0x07f55fff
 stwio  r3, 4(r2)					/*direction register*/

 movia  r9, 0xffffffff					/*turn off motors*/
 stwio  r9, 0(r2)					/*data register*/

 /* loading threshold value into all the sensors (1-5) for each register*/
 
 #sensor 1

 movia  r3,0xfbbffbff 			/* load threshold value HEX 7 for sensor 1 on lego controller*/
 stwio r3,0(r2)		        

#sensor 2

 movia  r3,0xfbbfefff 			/* load threshold value HEX 7 for sensor 2 on lego controller*/
 stwio r3,0(r2)	

#sensor 3

 movia  r3,0xfbbbffff 			/* load threshold value HEX 7 for sensor 3 on lego controller*/
 stwio r3,0(r2)	

#sensor 4

 movia  r3,0xfbbeffff 			/* load threshold value HEX 7 for sensor 4 on lego controller*/
 stwio r3,0(r2)	
 
 #sensor 5

 movia  r3,0xfbbbffff 			/* load threshold value HEX 7 for sensor 5 on lego controller*/
 stwio r3,0(r2)	

 movia  r3,0xffdfffff           /* turn on state mode */		   
 stwio  r3, 0(r2) 



 movia	r6,ADDR_REDLEDS
 stwio  r0,0(r6)					/*clear RED leds*/
 movi	r8,0x1
 


loop:

 movia	r7,ADDR_SWITCHES			/* check switch1 */
 ldwio 	r3,(r7)
 andi	r3,r3,0x1
 cmpeqi r3,r3,0x1
 bne	r8,r3,off

 
 ldwio	r4,(r2)						/* get state value for sensor 1-4*/

 srli	r4,r4,27			 		/* shift right to make sensor state first 4 bits*/
 andi	r4,r4,0xf					/* mask all 4 sensor bits*/
 
 stwio	r4,0(r6)					/* store 4 bit value and display on green LEDS 0-3*/
 andi	r4,r4,0x3					/*mask motor 1 and 2 for tank*/ 
 cmpeqi	r9,r4,0x1
 beq	r8,r9,mot1					/* check if motor 1 on*/
 cmpeqi	r9,r4,0x2
 beq	r8,r9,mot2					/* check if motor 2 on*/
 cmpeqi	r9,r4,0x0
 beq	r8,r9,both					/* check if both 1 and 2 are on*/

 br	off

mot1:

 movia	r9,0xffdffff3					/*motor 1 on state mode enabled*/
 stwio  r9,0(r2)
 br	over

mot2:

 movia	r9,0xffdffffc					/*motor 2 on state mode enabled*/
 stwio  r9,0(r2)
 br	over

both:

 movia	r9,0xffdffff0					/*both motors on state mode enabled*/
 stwio  r9,0(r2)
 br	over 

off:

 movia	r9,0xffdfffff					/*both motors off state mode enabled*/
 stwio 	r9,0(r2)

over:
 br	loop	
 
